package com.example.bump

import android.util.Log
import com.google.zxing.common.StringUtils
import java.security.SecureRandom
import java.util.Base64
import javax.crypto.spec.PBEKeySpec
import javax.crypto.SecretKeyFactory
import com.macasaet.fernet.Key
import com.macasaet.fernet.Token
import com.macasaet.fernet.StringValidator
import com.macasaet.fernet.Validator
import com.maenle.bump.MainActivity
import java.time.Duration
import java.time.temporal.TemporalAmount

class MessageProcessor {
    lateinit var sender:String
    lateinit var key: String

    fun codeValid(code: String): Boolean {
        return code.split("-").size >= KEY_LENGTH + SENDER_LENGTH
    }

    fun codeSave(new_code: String) {
        var code: List<String> = new_code.split("-")
        sender = code.subList(0, SENDER_LENGTH).joinToString("-")
        key = code.subList(SENDER_LENGTH, code.size).joinToString("-")
        Log.d(TAG, sender)
        Log.d(TAG, key)
    }

    fun decrypt(message : String) {
        // Data from encryption
        val decoded : ByteArray = Base64.getUrlDecoder().decode(message)
        val salt = decoded.copyOfRange(0, 16)
        val iter = decoded.copyOfRange(16, 20)
        val str_token = String(Base64.getUrlEncoder().encode(decoded.copyOfRange(20, decoded.size)))

        // Derive Fernet key
        val saltedKey = deriveKey(key, salt, 100_000)
        val fernetKey = Key(saltedKey)

        val token =
            Token.fromString(str_token);


        // Decrypt
        val validator: Validator<String> = object : StringValidator {
            override fun getTimeToLive(): TemporalAmount {
                return Duration.ofHours(196)
            }
        }
        val data = token.validateAndDecrypt(fernetKey, validator)
        Log.d(TAG, data )
    }

    fun deriveKey(password: String, salt: ByteArray, iterations : Int): String {
        val derivedKeyLength = 256
        val spec = PBEKeySpec(password.toCharArray(), salt, iterations, derivedKeyLength)
        val secretKeyFactory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA256")
        val key = secretKeyFactory.generateSecret(spec).encoded
        return Base64.getUrlEncoder().encodeToString(key)
    }

    companion object {
        private val TAG = MainActivity::class.java.simpleName
        val KEY_LENGTH = 8
        val SENDER_LENGTH = 4
    }


}